--- kaffe/libraries/javalib/makeJava.orig	Tue Jul 14 15:02:12 1998
+++ kaffe/libraries/javalib/makeJava	Thu Aug 20 19:47:41 1998
@@ -3,7 +3,7 @@
 # Simple little script which builds the .class files which are older
 # than the .java files.
 #
-# usage: makeJava [-srcdir path] [-dstdir path] java files ....
+# usage: makeJava [-srcdir path] [-dstdir path] {java files|all}
 #
 # Copyright (c) 1997, 1998
 #      Transvirtual Technologies, Inc.  All rights reserved.
@@ -17,10 +17,12 @@
 fi
 
 srcdir=.
-dstdir=.
+dstdir=lib
+alltopdirs="java kaffe"
+javac_cp="$dstdir:$srcdir:$CLASSPATH:$srcdir/Klasses.jar"
 
 if test "$*" = "" ; then
-	echo "usage: makeJava [-srcdir path] [-dstdir path] java files ...."
+	echo "usage: makeJava [-srcdir path] [-dstdir path] {java files|all}"
 	exit 1
 fi
 if test "$1" = "-srcdir" ; then
@@ -34,20 +36,52 @@
 	shift
 fi
 
-for file in $*
+if test x"$*" = xall; then
+	files=`cd $srcdir; find $alltopdirs -type f -name \*.java -print`
+else
+	files="$*"
+	addsrcdir=1
+fi
+
+errorlist=""
+
+for file in $files
 do
-	b=`echo $file | sed s/\\.java//`
-	jf=$b.java
-	cf=$b.class
+	b=`echo $file | sed s/\\.java$//`
+	jf=$srcdir/$b.java
+	cf=$dstdir/$b.class
 	docompile=0
-	if test ! -f $dstdir/$cf ; then
+	if test ! -f $cf ; then
 		docompile=1
-	elif test $dstdir/$cf -ot $srcdir/$jf ; then
+	elif test $cf -ot $jf ; then
 		docompile=1
 	fi
 	if test "$docompile" = "1" ; then
+		outdir=`dirname $cf`
+		if test ! -d $outdir; then
+			echo Creating directory $outdir
+			mkdir -p $outdir
+		fi
 		echo -n "Compiling $jf ... "
-		$JAVAC -classpath $dstdir:$srcdir:.:$CLASSPATH:./Klasses.jar -d $dstdir $srcdir/$jf || exit 1
-		echo "done"
+		$JAVAC -classpath $javac_cp -d $dstdir $jf
+		if test $? = 0; then
+			if test -f $cf; then
+				echo "done"
+			else
+				echo Fatal error while processing $jf
+				echo belonging to `grep ^package $jf`
+				exit 1
+			fi
+		else
+			errorlist="$errorlist $jf"
+			echo "not done"
+		fi
 	fi
 done
+
+if test x"$errorlist" != x; then
+	echo There were errors while compiling:
+	echo $errorlist
+else
+	echo No errors encountered
+fi
